part of LanguageTools;

// Object describing a position in multiline string
class Position {
    int row;
    int col;

    Position([this.row = 1, this.col = 0]);

    Position clone() => new Position(this.row, this.col);

    static Position from(pos) {
        if(pos is Position) {
            return pos.clone();
        } else if(pos is Map) {
            if(!pos.containsKey('row'))
                pos['row'] = 1;
            if(!pos.containsKey('col'))
                pos['col'] = 0;
            return new Position(pos['row'], pos['col']);
        }
    }
}